/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.NotesDatabaseHelper.TABLE;
import net.micode.notes.gtask.exception.ActionFailureException;

import org.json.JSONException;
import org.json.JSONObject;


public class SqlData {
    private static final String TAG = SqlData.class.getSimpleName(); // 日志标签

    private static final int INVALID_ID = -99999; // 无效ID常量

    public static final String[] PROJECTION_DATA = new String[] {
            DataColumns.ID, DataColumns.MIME_TYPE, DataColumns.CONTENT, DataColumns.DATA1,
            DataColumns.DATA3
    }; // 数据列投影

    public static final int DATA_ID_COLUMN = 0; // 数据ID列索引

    public static final int DATA_MIME_TYPE_COLUMN = 1; // 数据MIME类型列索引

    public static final int DATA_CONTENT_COLUMN = 2; // 数据内容列索引

    public static final int DATA_CONTENT_DATA_1_COLUMN = 3; // 数据内容数据1列索引

    public static final int DATA_CONTENT_DATA_3_COLUMN = 4; // 数据内容数据3列索引

    private ContentResolver mContentResolver; // 内容解析器

    private boolean mIsCreate; // 是否为创建标志

    private long mDataId; // 数据ID

    private String mDataMimeType; // 数据MIME类型

    private String mDataContent; // 数据内容

    private long mDataContentData1; // 数据内容数据1

    private String mDataContentData3; // 数据内容数据3

    private ContentValues mDiffDataValues; // 差异数据值

    public SqlData(Context context) {
        mContentResolver = context.getContentResolver(); // 获取内容解析器
        mIsCreate = true; // 设置为创建标志
        mDataId = INVALID_ID; // 初始化数据ID
        mDataMimeType = DataConstants.NOTE; // 初始化数据MIME类型
        mDataContent = ""; // 初始化数据内容
        mDataContentData1 = 0; // 初始化数据内容数据1
        mDataContentData3 = ""; // 初始化数据内容数据3
        mDiffDataValues = new ContentValues(); // 初始化差异数据值
    }

    public SqlData(Context context, Cursor c) {
        mContentResolver = context.getContentResolver(); // 获取内容解析器
        mIsCreate = false; // 设置为非创建标志
        loadFromCursor(c); // 从游标加载数据
        mDiffDataValues = new ContentValues(); // 初始化差异数据值
    }

    private void loadFromCursor(Cursor c) {
        mDataId = c.getLong(DATA_ID_COLUMN); // 从游标获取数据ID
        mDataMimeType = c.getString(DATA_MIME_TYPE_COLUMN); // 从游标获取数据MIME类型
        mDataContent = c.getString(DATA_CONTENT_COLUMN); // 从游标获取数据内容
        mDataContentData1 = c.getLong(DATA_CONTENT_DATA_1_COLUMN); // 从游标获取数据内容数据1
        mDataContentData3 = c.getString(DATA_CONTENT_DATA_3_COLUMN); // 从游标获取数据内容数据3
    }

    public void setContent(JSONObject js) throws JSONException {
        long dataId = js.has(DataColumns.ID) ? js.getLong(DataColumns.ID) : INVALID_ID; // 获取JSON中的数据ID
        if (mIsCreate || mDataId != dataId) {
            mDiffDataValues.put(DataColumns.ID, dataId); // 更新差异数据值中的数据ID
        }
        mDataId = dataId; // 更新数据ID

        String dataMimeType = js.has(DataColumns.MIME_TYPE) ? js.getString(DataColumns.MIME_TYPE)
                : DataConstants.NOTE; // 获取JSON中的数据MIME类型
        if (mIsCreate || !mDataMimeType.equals(dataMimeType)) {
            mDiffDataValues.put(DataColumns.MIME_TYPE, dataMimeType); // 更新差异数据值中的数据MIME类型
        }
        mDataMimeType = dataMimeType; // 更新数据MIME类型

        String dataContent = js.has(DataColumns.CONTENT) ? js.getString(DataColumns.CONTENT) : ""; // 获取JSON中的数据内容
        if (mIsCreate || !mDataContent.equals(dataContent)) {
            mDiffDataValues.put(DataColumns.CONTENT, dataContent); // 更新差异数据值中的数据内容
        }
        mDataContent = dataContent; // 更新数据内容

        long dataContentData1 = js.has(DataColumns.DATA1) ? js.getLong(DataColumns.DATA1) : 0; // 获取JSON中的数据内容数据1
        if (mIsCreate || mDataContentData1 != dataContentData1) {
            mDiffDataValues.put(DataColumns.DATA1, dataContentData1); // 更新差异数据值中的数据内容数据1
        }
        mDataContentData1 = dataContentData1; // 更新数据内容数据1

        String dataContentData3 = js.has(DataColumns.DATA3) ? js.getString(DataColumns.DATA3) : ""; // 获取JSON中的数据内容数据3
        if (mIsCreate || !mDataContentData3.equals(dataContentData3)) {
            mDiffDataValues.put(DataColumns.DATA3, dataContentData3); // 更新差异数据值中的数据内容数据3
        }
        mDataContentData3 = dataContentData3; // 更新数据内容数据3
    }

    public JSONObject getContent() throws JSONException {
        if (mIsCreate) {
            Log.e(TAG, "it seems that we haven't created this in database yet"); // 日志记录错误信息
            return null;
        }
        JSONObject js = new JSONObject(); // 创建JSON对象
        js.put(DataColumns.ID, mDataId); // 将数据ID放入JSON对象
        js.put(DataColumns.MIME_TYPE, mDataMimeType); // 将数据MIME类型放入JSON对象
        js.put(DataColumns.CONTENT, mDataContent); // 将数据内容放入JSON对象
        js.put(DataColumns.DATA1, mDataContentData1); // 将数据内容数据1放入JSON对象
        js.put(DataColumns.DATA3, mDataContentData3); // 将数据内容数据3放入JSON对象
        return js; // 返回JSON对象
    }

    public void commit(long noteId, boolean validateVersion, long version) {

        if (mIsCreate) {
            if (mDataId == INVALID_ID && mDiffDataValues.containsKey(DataColumns.ID)) {
                mDiffDataValues.remove(DataColumns.ID); // 移除差异数据值中的数据ID
            }

            mDiffDataValues.put(DataColumns.NOTE_ID, noteId); // 将笔记ID放入差异数据值
            Uri uri = mContentResolver.insert(Notes.CONTENT_DATA_URI, mDiffDataValues); // 插入数据
            try {
                mDataId = Long.valueOf(uri.getPathSegments().get(1)); // 获取插入数据的ID
            } catch (NumberFormatException e) {
                Log.e(TAG, "Get note id error :" + e.toString()); // 日志记录错误信息
                throw new ActionFailureException("create note failed"); // 抛出操作失败异常
            }
        } else {
            if (mDiffDataValues.size() > 0) {
                int result = 0;
                if (!validateVersion) {
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues, null, null); // 更新数据
                } else {
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues,
                            " ? in (SELECT " + NoteColumns.ID + " FROM " + TABLE.NOTE
                                    + " WHERE " + NoteColumns.VERSION + "=?)", new String[] {
                                    String.valueOf(noteId), String.valueOf(version)
                            }); // 更新数据并验证版本
                }
                if (result == 0) {
                    Log.w(TAG, "there is no update. maybe user updates note when syncing"); // 日志记录警告信息
                }
            }
        }

        mDiffDataValues.clear(); // 清空差异数据值
        mIsCreate = false; // 设置为非创建标志
    }

    public long getId() {
        return mDataId; // 返回数据ID
    }
}
